Core - Bug # 63812

Bug # 63692 (Accepted): Memory consumption while bulk inserting

Status: Resolved Priority: Should have
Author: Stephan GroBberndt Category: Performance
Created: 2014-12-12 Assigned To: Stephan GroBberndt
Updated: 2014-12-17 Due date:

TYPO3 Version: 6.2

PHP Version:

Complexity: no-brainer

Is Regression: No

Sprint Focus:

Subject: Lower memory use in ArrayUtil->mergeRecursiveWithOverrule

Description

Currently ArrayUtil->mergeRecursiveWithOverrule uses foreach (array_keys($overrule) as $key) to iterate the keys. This means a new
array consisting only of the keys has to be created which costs performance and memory:

static public function mergeRecursiveWithOverrule(array &$original, array $overrule, $addKeys = TRUE, $includeEmptyValues

= TRUE, $enableUnsetFeature = TRUE) {
foreach (array_keys($overrule) as $key) {

Replacing this with

foreach ($overrule as $key => $unusedValue)

drastically lowers memory usage and enhances performance.

Related issues:
related to Core - Task # 54251: GeneralUtility::array_merge_recursive_overrul... Resolved 2013-12-06

Associated revisions

Revision babd2626 - 2014-12-17 09:01 - Stephan GroBberndt

[TASK] Lower memory use in ArrayUtil->mergeRecursiveWithOverrule

Iterate on the original array instead of an array_keys()-copy in
ArrayUtil->mergeRecursiveWithOverrule which lowers memory usage and

enhances performance.

Resolves: #63812

Releases: master, 6.2

Change-Id: 171acc9e1e730f1e782d0e74acd45637ce1b9f08e
Reviewed-on: http://review.typo3.0rg/35351

Reviewed-by: Anja Leichsenring <aleichsenring@ab-softlab.de>

Tested-by: Anja Leichsenring <aleichsenring@ab-softlab.de>

Reviewed-by: Christian Kuhn <lolli@schwarzbu.ch>
Tested-by: Christian Kuhn <lolli@schwarzbu.ch>
Reviewed-by: Wouter Wolters <typo3@wouterwolters.nl>

Tested-by: Wouter Wolters <typo3@wouterwolters.nl>

Revision ea33fb5f - 2014-12-17 09:01 - Stephan GroBberndt

[TASK] Lower memory use in ArrayUtil->mergeRecursiveWithOverrule

Iterate on the original array instead of an array_keys()-copy in
ArrayUtil->mergeRecursiveWithOverrule which lowers memory usage and

enhances performance.

Resolves: #63812

Releases: master, 6.2

Change-Id: 171acc9e1e730f1e782d0e74acd45637ce1b9f08e
Reviewed-on: http:/review.typo3.0rg/35535

Reviewed-by: Markus Klein <klein.t3@reelworx.at>

Tested-by: Markus Klein <klein.t3@reelworx.at>

History

#1 - 2014-12-12 14:58 - Gerrit Code Review

- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/35351

#2 - 2014-12-12 15:07 - Mathias Schreiber
- Parent task set to #63692

#3 - 2014-12-12 16:19 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35351

#4 - 2014-12-12 16:51 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/35351

#5 - 2014-12-12 23:33 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35351

#6 - 2014-12-12 23:33 - Gerrit Code Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

2015-08-04

2/3


mailto:typo3@wouterwolters.nl
mailto:typo3@wouterwolters.nl
http://review.typo3.org/35535
mailto:klein.t3@reelworx.at
mailto:klein.t3@reelworx.at
http://review.typo3.org/35351
http://review.typo3.org/35351
http://review.typo3.org/35351
http://review.typo3.org/35351

It is available at http://review.typo3.0rg/35373

#7 - 2014-12-13 12:44 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/35373

#8 - 2014-12-13 13:32 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/35373

#9 - 2014-12-13 14:17 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/35373

#10 - 2014-12-14 17:19 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/35373

#11 - 2014-12-17 09:02 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35535

#12 - 2014-12-17 09:30 - Stephan GroBberndt
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset commit:babd2626f2be330ba788026d97b74f0e5458bea3.
